// THIS IS AN INITIAL IMPLEMENTATION OF MATCHERCELLS
// YOU NEED A JAVASCRIPT INTERPRETER TO EXECUTE THIS FILE


//HELPER FUNCTIONS ==============================================
var map = function(array,fun, arg) {
    return array.map(function(el) {
        return fun(el,arg);
    });
};

var removeDuplicated = function (array){
    var newArray = [];
    for (var i = 0; i < array.length; ++i) {
        var duplicated = false;
        for (var j = 0; j < newArray.length; ++j) {
            if (array[i] == newArray[j]) {
                duplicated = true;
                break;
            }
        }
        if (!duplicated) {
            newArray.push(array[i]);
        }
    }
    return newArray;
};

var append = function(array1, array2) {
    return array1.concat(array2);
};

var adv = function (){
    print("M");
};

var NoMatchCells = function (cells){
    for(var i = 0; i < cells.length; ++i){
        if(!cells[i].isMatch()){
            return false;
        }
    }
    return true;
};

//Weaving of a stateful aspect and the evaluation of a cell ====================
var weaving = function (sAsp, jps){
    print("weaving of " + jps);
    for(var i = 0; i < jps.length; ++i){
        print("jp:" + jps[i]);
        var matches = sAsp.eval(jps[i]);
        for(var j = 1; j <= matches; ++j){
            sAsp.advice();
        }
    }
};

var StatefulAspect = function (sequence, advice, rule){
    this.advice = advice;
    this.sequence = sequence;
    this.rule = rule;

    var cells = [new Cell(sequence)];

    this.eval = function (jp){
        cells = this.rule(cells, jp);
        var matches = this.match();
        cells = cells.filter(function (cell){
            return !cell.isMatch();
        });
        return matches;
    };

    this.match = function (){
        var cont = 0;
        cells.forEach(function (cell){
            cont += cell.isMatch() ? 1 : 0;
        });
        return cont;
    };
};

var Cell = function (sequence){
    this.eval = function (jp){
        return sequence[0] == jp? new Cell(sequence.substr(1)): this;
    };

    this.isMatch = function (){
        return sequence == "";
    };

    this.toString = function (){
        return sequence;
    };
};

var eval = function (cell, jp){
    return cell.eval(jp);
};

//RULES =================================
var evalCells = function (cells, jp){
    return map(cells, eval, jp);
};

var dontkillMatched = function (rule){
    return function (cells, jp){
        return removeDuplicated(append(rule.call(this, cells, jp),cells));
    }
};

var addSeed = function (rule){
    return function (cells, jp){
        var newCells = rule.call(this, cells, jp);
        //print("l:" + isNocells(newCells));
        return cells.length == 0|| NoMatchCells(newCells) ?
               append(newCells, new Cell(this.sequence)) : newCells;
    }
};

var cellsWithDifferentInformation = function (rule){
    return function (cells, jp){
        var newCells = rule(cells, jp);
        return newCells.filter(newCells, function (cell){
            return hasDifferentBindings(cell, newCells);
        });
    }
};


// SOME TESTS================================
weaving(new StatefulAspect("ab", adv, evalCells), "aab");
weaving(new StatefulAspect("ab", adv, dontkillMatched(evalCells)), "aab");
weaving(new StatefulAspect("ab", adv, addSeed(evalCells)), "aabab");
